unit uTesterMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,Menus, StdCtrls,
   WinSkinStore, WinSkinData,  winskindlg, ComCtrls ;

type
  TForm1 = class(TForm)
    btnShowDLL: TButton;
    btnHideDLL: TButton;
    SkinData1: TSkinData;
    SkinStore1: TSkinStore;
    cbbxSkins: TComboBox;
    ckbxUseSkin: TCheckBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    REcord1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    New1: TMenuItem;
    Save2: TMenuItem;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    N11111111: TMenuItem;
    N22222221: TMenuItem;
    N3333331: TMenuItem;
    N44444441: TMenuItem;
    N55555551: TMenuItem;
    N666666661: TMenuItem;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ScrollBar1: TScrollBar;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Memo1: TMemo;
    Label2: TLabel;
    procedure btnShowDLLClick(Sender: TObject);
    procedure btnHideDLLClick(Sender: TObject);
    procedure ckbxUseSkinClick(Sender: TObject);
    procedure cbbxSkinsChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

TShowFunc = procedure();stdcall;
TSkinDll = procedure(ahandle: HWnd;adata: Pointer);stdcall;

var
  Form1: TForm1;
  init:boolean;
  showfm,hidefm:TshowFunc;
  SetApp:Tskindll;
  lib:Thandle;

implementation

//procedure ShowDLLForm; external 'DLLTest.dll';
//procedure HideDLLForm; external 'DLLTest.dll';
//procedure SetApplicationHandle(Handle: HWnd;adata: Pointer); external 'DLLTest.dll';

{$R *.dfm}

procedure LoadDLL;
begin
  Lib := LoadLibrary('dlltest.dll');
  if lib<>0 then begin
     @Showfm := GetProcAddress(Lib,'ShowDLLForm');
     @Hidefm := GetProcAddress(Lib,'HideDLLForm');
     @setApp := GetProcAddress(Lib,'SetApplicationHandle');
  end;
end;

procedure FreeDLL;
begin
   if lib<>0 then freeLibrary(lib);
   lib:=0;
end;

procedure TForm1.btnShowDLLClick(Sender: TObject);
begin
  if lib=0 then begin
     loaddll;
     SetApp(Application.Handle,winskindlg.skinmanager);
  end;
  if @showfm<>nil then
     Showfm();
end;

procedure TForm1.btnHideDLLClick(Sender: TObject);
begin
//  if @hidefm<>nil then
//     hidefm;
  freedll;
end;

procedure TForm1.ckbxUseSkinClick(Sender: TObject);
begin
  SkinData1.Active := ckbxUseSkin.Checked;
end;

procedure TForm1.cbbxSkinsChange(Sender: TObject);
Var
   I : Integer;
begin
   i:=cbbxSkins.ItemIndex;
   SkinData1.LoadFromCollection(skinstore1,i);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   FreeDLL;
   close;
 //  opendialog1.Execute;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   FreeDLL;
end;

end.
